/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  net.minecraft.block.Block
 *  net.minecraft.block.BlockBarrier
 *  net.minecraft.block.BlockBed
 *  net.minecraft.block.BlockCactus
 *  net.minecraft.block.BlockCarpet
 *  net.minecraft.block.BlockChest
 *  net.minecraft.block.BlockEndPortal
 *  net.minecraft.block.BlockEndPortalFrame
 *  net.minecraft.block.BlockEnderChest
 *  net.minecraft.block.BlockFence
 *  net.minecraft.block.BlockGlass
 *  net.minecraft.block.BlockLadder
 *  net.minecraft.block.BlockPane
 *  net.minecraft.block.BlockPistonBase
 *  net.minecraft.block.BlockPistonExtension
 *  net.minecraft.block.BlockPistonMoving
 *  net.minecraft.block.BlockSkull
 *  net.minecraft.block.BlockSlab
 *  net.minecraft.block.BlockStainedGlass
 *  net.minecraft.block.BlockStairs
 *  net.minecraft.block.BlockTrapDoor
 *  net.minecraft.block.BlockWall
 *  net.minecraft.block.BlockWeb
 *  net.minecraft.client.Minecraft
 *  net.minecraft.util.BlockPos
 */
package net.aspw.client.util.pathfinder;

import java.util.ArrayList;
import java.util.Comparator;
import net.aspw.client.util.pathfinder.PathHub;
import net.aspw.client.util.pathfinder.Vec3;
import net.minecraft.block.Block;
import net.minecraft.block.BlockBarrier;
import net.minecraft.block.BlockBed;
import net.minecraft.block.BlockCactus;
import net.minecraft.block.BlockCarpet;
import net.minecraft.block.BlockChest;
import net.minecraft.block.BlockEndPortal;
import net.minecraft.block.BlockEndPortalFrame;
import net.minecraft.block.BlockEnderChest;
import net.minecraft.block.BlockFence;
import net.minecraft.block.BlockGlass;
import net.minecraft.block.BlockLadder;
import net.minecraft.block.BlockPane;
import net.minecraft.block.BlockPistonBase;
import net.minecraft.block.BlockPistonExtension;
import net.minecraft.block.BlockPistonMoving;
import net.minecraft.block.BlockSkull;
import net.minecraft.block.BlockSlab;
import net.minecraft.block.BlockStainedGlass;
import net.minecraft.block.BlockStairs;
import net.minecraft.block.BlockTrapDoor;
import net.minecraft.block.BlockWall;
import net.minecraft.block.BlockWeb;
import net.minecraft.client.Minecraft;
import net.minecraft.util.BlockPos;

public class PathFinder {
    private final Vec3 startVec3Path;
    private final Vec3 endVec3Path;
    private ArrayList<Vec3> path = new ArrayList();
    private final ArrayList<PathHub> pathHubs = new ArrayList();
    private final ArrayList<PathHub> workingPathHubList = new ArrayList();
    private static final Vec3[] directions = new Vec3[]{new Vec3(1.0, 0.0, 0.0), new Vec3(-1.0, 0.0, 0.0), new Vec3(0.0, 0.0, 1.0), new Vec3(0.0, 0.0, -1.0)};

    public PathFinder(Vec3 startVec3Path, Vec3 endVec3Path) {
        this.startVec3Path = startVec3Path.addVector(0.0, 0.0, 0.0).floor();
        this.endVec3Path = endVec3Path.addVector(0.0, 0.0, 0.0).floor();
    }

    public ArrayList<Vec3> getPath() {
        return this.path;
    }

    public void compute() {
        this.compute(1000, 4);
    }

    public void compute(int loops, int depth) {
        this.path.clear();
        this.workingPathHubList.clear();
        ArrayList<Vec3> initPath = new ArrayList<Vec3>();
        initPath.add(this.startVec3Path);
        this.workingPathHubList.add(new PathHub(this.startVec3Path, null, initPath, this.startVec3Path.squareDistanceTo(this.endVec3Path), 0.0, 0.0));
        block0: for (int i = 0; i < loops; ++i) {
            this.workingPathHubList.sort(new CompareHub());
            int j = 0;
            if (this.workingPathHubList.size() == 0) break;
            for (PathHub pathHub : new ArrayList<PathHub>(this.workingPathHubList)) {
                Vec3 loc2;
                if (++j > depth) continue block0;
                this.workingPathHubList.remove(pathHub);
                this.pathHubs.add(pathHub);
                for (Vec3 direction : directions) {
                    Vec3 loc = pathHub.getLoc().add(direction).floor();
                    if (PathFinder.isValid(loc, false) && this.putHub(pathHub, loc, 0.0)) break block0;
                }
                Vec3 loc1 = pathHub.getLoc().addVector(0.0, 1.0, 0.0).floor();
                if ((!PathFinder.isValid(loc1, false) || !this.putHub(pathHub, loc1, 0.0)) && (!PathFinder.isValid(loc2 = pathHub.getLoc().addVector(0.0, -1.0, 0.0).floor(), false) || !this.putHub(pathHub, loc2, 0.0))) continue;
                break block0;
            }
        }
        this.pathHubs.sort(new CompareHub());
        this.path = this.pathHubs.get(0).getPathway();
    }

    public static boolean isValid(Vec3 loc, boolean checkGround) {
        return PathFinder.isValid((int)loc.getX(), (int)loc.getY(), (int)loc.getZ(), checkGround);
    }

    public static boolean isValid(int x, int y, int z, boolean checkGround) {
        BlockPos block1 = new BlockPos(x, y, z);
        BlockPos block2 = new BlockPos(x, y + 1, z);
        BlockPos block3 = new BlockPos(x, y - 1, z);
        return !PathFinder.isNotPassable(block1) && !PathFinder.isNotPassable(block2) && (PathFinder.isNotPassable(block3) || !checkGround) && PathFinder.canWalkOn(block3);
    }

    private static boolean isNotPassable(BlockPos block) {
        Block b = Minecraft.getMinecraft().theWorld.getBlockState(new BlockPos(block.getX(), block.getY(), block.getZ())).getBlock();
        return b.isFullBlock() || b instanceof BlockSlab || b instanceof BlockStairs || b instanceof BlockCactus || b instanceof BlockChest || b instanceof BlockEnderChest || b instanceof BlockSkull || b instanceof BlockPane || b instanceof BlockFence || b instanceof BlockWall || b instanceof BlockGlass || b instanceof BlockPistonBase || b instanceof BlockPistonExtension || b instanceof BlockPistonMoving || b instanceof BlockStainedGlass || b instanceof BlockTrapDoor || b instanceof BlockEndPortalFrame || b instanceof BlockEndPortal || b instanceof BlockBed || b instanceof BlockWeb || b instanceof BlockBarrier || b instanceof BlockLadder || b instanceof BlockCarpet;
    }

    private static boolean canWalkOn(BlockPos block) {
        return !(Minecraft.getMinecraft().theWorld.getBlockState(new BlockPos(block.getX(), block.getY(), block.getZ())).getBlock() instanceof BlockFence) && !(Minecraft.getMinecraft().theWorld.getBlockState(new BlockPos(block.getX(), block.getY(), block.getZ())).getBlock() instanceof BlockWall);
    }

    public PathHub doesHubExistAt(Vec3 loc) {
        for (PathHub pathHub : this.pathHubs) {
            if (pathHub.getLoc().getX() != loc.getX() || pathHub.getLoc().getY() != loc.getY() || pathHub.getLoc().getZ() != loc.getZ()) continue;
            return pathHub;
        }
        for (PathHub pathHub : this.workingPathHubList) {
            if (pathHub.getLoc().getX() != loc.getX() || pathHub.getLoc().getY() != loc.getY() || pathHub.getLoc().getZ() != loc.getZ()) continue;
            return pathHub;
        }
        return null;
    }

    public boolean putHub(PathHub parent, Vec3 loc, double cost) {
        PathHub existingPathHub = this.doesHubExistAt(loc);
        double totalCost = cost;
        if (parent != null) {
            totalCost += parent.getMaxCost();
        }
        if (existingPathHub == null) {
            if (loc.getX() == this.endVec3Path.getX() && loc.getY() == this.endVec3Path.getY() && loc.getZ() == this.endVec3Path.getZ() || loc.squareDistanceTo(this.endVec3Path) <= 1.0) {
                this.path.clear();
                this.path = parent.getPathway();
                this.path.add(loc);
                return true;
            }
            ArrayList<Vec3> path = new ArrayList<Vec3>(parent.getPathway());
            path.add(loc);
            this.workingPathHubList.add(new PathHub(loc, parent, path, loc.squareDistanceTo(this.endVec3Path), cost, totalCost));
        } else if (existingPathHub.getCurrentCost() > cost) {
            ArrayList<Vec3> path = new ArrayList<Vec3>(parent.getPathway());
            path.add(loc);
            existingPathHub.setLoc(loc);
            existingPathHub.setParentPathHub(parent);
            existingPathHub.setPathway(path);
            existingPathHub.setSqDist(loc.squareDistanceTo(this.endVec3Path));
            existingPathHub.setCurrentCost(cost);
            existingPathHub.setMaxCost(totalCost);
        }
        return false;
    }

    public static class CompareHub
    implements Comparator<PathHub> {
        @Override
        public int compare(PathHub o1, PathHub o2) {
            return (int)(o1.getSqDist() + o1.getMaxCost() - (o2.getSqDist() + o2.getMaxCost()));
        }
    }
}

