/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.google.gson.GsonBuilder
 *  com.google.gson.JsonArray
 *  com.google.gson.JsonElement
 *  com.google.gson.JsonNull
 *  com.google.gson.JsonObject
 *  com.google.gson.JsonParser
 *  net.minecraft.client.Minecraft
 *  net.minecraft.client.gui.FontRenderer
 */
package net.aspw.client.visual.font;

import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonElement;
import com.google.gson.JsonNull;
import com.google.gson.JsonObject;
import com.google.gson.JsonParser;
import java.awt.Font;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;
import java.io.Reader;
import java.lang.reflect.Field;
import java.util.ArrayList;
import java.util.List;
import java.util.zip.ZipEntry;
import java.util.zip.ZipInputStream;
import net.aspw.client.Client;
import net.aspw.client.util.ClientUtils;
import net.aspw.client.util.misc.HttpUtils;
import net.aspw.client.visual.font.FontDetails;
import net.aspw.client.visual.font.GameFontRenderer;
import net.aspw.client.visual.font.TTFFontRenderer;
import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.FontRenderer;

public class Fonts {
    @FontDetails(fontName="Minecraft Font")
    public static final FontRenderer minecraftFont = Minecraft.getMinecraft().fontRendererObj;
    private static final List<GameFontRenderer> CUSTOM_FONT_RENDERERS = new ArrayList<GameFontRenderer>();
    @FontDetails(fontName="Roboto Medium", fontSize=35)
    public static GameFontRenderer font35;
    @FontDetails(fontName="Roboto Medium", fontSize=40)
    public static GameFontRenderer font40;
    @FontDetails(fontName="Roboto Medium", fontSize=72)
    public static GameFontRenderer font72;
    @FontDetails(fontName="Roboto Medium", fontSize=30)
    public static GameFontRenderer fontSmall;
    @FontDetails(fontName="Roboto Medium", fontSize=24)
    public static GameFontRenderer fontTiny;
    @FontDetails(fontName="Roboto Medium", fontSize=52)
    public static GameFontRenderer fontLarge;
    @FontDetails(fontName="SFUI Regular", fontSize=35)
    public static GameFontRenderer fontSFUI35;
    @FontDetails(fontName="SFUI Regular", fontSize=37)
    public static GameFontRenderer fontSFUI37;
    @FontDetails(fontName="SFUI Regular", fontSize=40)
    public static GameFontRenderer fontSFUI40;
    @FontDetails(fontName="Jello Regular", fontSize=40)
    public static GameFontRenderer jelloRegular40;
    @FontDetails(fontName="Roboto Bold", fontSize=180)
    public static GameFontRenderer fontBold180;
    @FontDetails(fontName="Tahoma Bold", fontSize=38)
    public static GameFontRenderer fontTahoma38;
    @FontDetails(fontName="Tahoma Bold", fontSize=35)
    public static GameFontRenderer fontTahoma;
    @FontDetails(fontName="Tahoma Bold", fontSize=30)
    public static GameFontRenderer fontTahoma30;
    public static TTFFontRenderer fontTahomaSmall;
    @FontDetails(fontName="Bangers", fontSize=45)
    public static GameFontRenderer fontBangers;
    @FontDetails(fontName="Pixel", fontSize=48)
    public static GameFontRenderer fontPixel;
    @FontDetails(fontName="Mojangles", fontSize=60)
    public static GameFontRenderer mojangles;
    @FontDetails(fontName="Mojangles Bold", fontSize=60)
    public static GameFontRenderer mojanglesBold;
    @FontDetails(fontName="NiSans", fontSize=60)
    public static GameFontRenderer niSans;
    @FontDetails(fontName="Icons", fontSize=52)
    public static GameFontRenderer icons;

    public static void loadFonts() {
        long l = System.currentTimeMillis();
        ClientUtils.getLogger().info("Loading Fonts...");
        Fonts.downloadFonts();
        font35 = new GameFontRenderer(Fonts.getFont("Roboto-Medium.ttf", 35));
        font40 = new GameFontRenderer(Fonts.getFont("Roboto-Medium.ttf", 40));
        font72 = new GameFontRenderer(Fonts.getFont("Roboto-Medium.ttf", 72));
        fontSmall = new GameFontRenderer(Fonts.getFont("Roboto-Medium.ttf", 30));
        fontTiny = new GameFontRenderer(Fonts.getFont("Roboto-Medium.ttf", 24));
        fontLarge = new GameFontRenderer(Fonts.getFont("Roboto-Medium.ttf", 60));
        fontSFUI35 = new GameFontRenderer(Fonts.getFont("sfui.ttf", 35));
        fontSFUI37 = new GameFontRenderer(Fonts.getFont("sfui.ttf", 37));
        fontSFUI40 = new GameFontRenderer(Fonts.getFont("sfui.ttf", 40));
        jelloRegular40 = new GameFontRenderer(Fonts.getFont("jelloregular.ttf", 40));
        fontBold180 = new GameFontRenderer(Fonts.getFont("Roboto-Bold.ttf", 180));
        fontTahoma = new GameFontRenderer(Fonts.getFont("TahomaBold.ttf", 35));
        fontTahoma30 = new GameFontRenderer(Fonts.getFont("TahomaBold.ttf", 30));
        fontTahoma38 = new GameFontRenderer(Fonts.getFont("TahomaBold.ttf", 38));
        fontTahomaSmall = new TTFFontRenderer(Fonts.getFont("Tahoma.ttf", 11));
        fontBangers = new GameFontRenderer(Fonts.getFont("Bangers-Regular.ttf", 45));
        fontPixel = new GameFontRenderer(Fonts.getFont("Pixel.ttf", 48));
        mojangles = new GameFontRenderer(Fonts.getFont("Mojangles.ttf", 60));
        mojanglesBold = new GameFontRenderer(Fonts.getFont("MojanglesBold.ttf", 60));
        niSans = new GameFontRenderer(Fonts.getFont("NiSans.ttf", 60));
        icons = new GameFontRenderer(Fonts.getFont("Icons.ttf", 52));
        try {
            CUSTOM_FONT_RENDERERS.clear();
            File fontsFile = new File(Client.fileManager.fontsDir, "fonts.json");
            if (fontsFile.exists()) {
                JsonElement jsonElement = new JsonParser().parse((Reader)new BufferedReader(new FileReader(fontsFile)));
                if (jsonElement instanceof JsonNull) {
                    return;
                }
                JsonArray jsonArray = (JsonArray)jsonElement;
                for (JsonElement element : jsonArray) {
                    if (element instanceof JsonNull) {
                        return;
                    }
                    JsonObject fontObject = (JsonObject)element;
                    CUSTOM_FONT_RENDERERS.add(new GameFontRenderer(Fonts.getFont(fontObject.get("fontFile").getAsString(), fontObject.get("fontSize").getAsInt())));
                }
            } else {
                fontsFile.createNewFile();
                PrintWriter printWriter = new PrintWriter(new FileWriter(fontsFile));
                printWriter.println(new GsonBuilder().setPrettyPrinting().create().toJson((JsonElement)new JsonArray()));
                printWriter.close();
            }
        }
        catch (Exception e) {
            e.printStackTrace();
        }
        ClientUtils.getLogger().info("Loaded Fonts. (" + (System.currentTimeMillis() - l) + "ms)");
    }

    private static void downloadFonts() {
        try {
            File outputFile = new File(Client.fileManager.fontsDir, "roboto.zip");
            File sfuiFile = new File(Client.fileManager.fontsDir, "sfui.ttf");
            File jelloFile = new File(Client.fileManager.fontsDir, "jelloregular.ttf");
            File prodSansFile = new File(Client.fileManager.fontsDir, "Roboto-Medium.ttf");
            File prodBoldFile = new File(Client.fileManager.fontsDir, "Roboto-Bold.ttf");
            File tahomaFile = new File(Client.fileManager.fontsDir, "TahomaBold.ttf");
            File tahomaReFile = new File(Client.fileManager.fontsDir, "Tahoma.ttf");
            File bangersFile = new File(Client.fileManager.fontsDir, "Bangers-Regular.ttf");
            File pixelFile = new File(Client.fileManager.fontsDir, "Pixel.ttf");
            if (!(outputFile.exists() && sfuiFile.exists() && jelloFile.exists() && prodSansFile.exists() && prodBoldFile.exists() && tahomaFile.exists() && tahomaReFile.exists() && bangersFile.exists() && pixelFile.exists())) {
                ClientUtils.getLogger().info("Downloading fonts...");
                HttpUtils.download("https://nightx.skidded.host/s/jldpbehytt", outputFile);
                ClientUtils.getLogger().info("Extract fonts...");
                Fonts.extractZip(outputFile.getPath(), Client.fileManager.fontsDir.getPath());
            }
        }
        catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static FontRenderer getFontRenderer(String name, int size) {
        for (Field field : Fonts.class.getDeclaredFields()) {
            try {
                FontDetails fontDetails;
                field.setAccessible(true);
                Object o = field.get(null);
                if (!(o instanceof FontRenderer) || !(fontDetails = field.getAnnotation(FontDetails.class)).fontName().equals(name) || fontDetails.fontSize() != size) continue;
                return (FontRenderer)o;
            }
            catch (IllegalAccessException e) {
                e.printStackTrace();
            }
        }
        for (GameFontRenderer liquidFontRenderer : CUSTOM_FONT_RENDERERS) {
            Font font = liquidFontRenderer.getDefaultFont().getFont();
            if (!font.getName().equals(name) || font.getSize() != size) continue;
            return liquidFontRenderer;
        }
        return minecraftFont;
    }

    public static Object[] getFontDetails(FontRenderer fontRenderer) {
        for (Field field : Fonts.class.getDeclaredFields()) {
            try {
                field.setAccessible(true);
                Object o = field.get(null);
                if (!o.equals(fontRenderer)) continue;
                FontDetails fontDetails = field.getAnnotation(FontDetails.class);
                return new Object[]{fontDetails.fontName(), fontDetails.fontSize()};
            }
            catch (IllegalAccessException e) {
                e.printStackTrace();
            }
        }
        if (fontRenderer instanceof GameFontRenderer) {
            Font font = ((GameFontRenderer)fontRenderer).getDefaultFont().getFont();
            return new Object[]{font.getName(), font.getSize()};
        }
        return null;
    }

    public static List<FontRenderer> getFonts() {
        ArrayList<FontRenderer> fonts = new ArrayList<FontRenderer>();
        for (Field fontField : Fonts.class.getDeclaredFields()) {
            try {
                fontField.setAccessible(true);
                Object fontObj = fontField.get(null);
                if (!(fontObj instanceof FontRenderer)) continue;
                fonts.add((FontRenderer)fontObj);
            }
            catch (IllegalAccessException e) {
                e.printStackTrace();
            }
        }
        fonts.addAll(CUSTOM_FONT_RENDERERS);
        return fonts;
    }

    private static Font getFont(String fontName, int size) {
        try {
            FileInputStream inputStream = new FileInputStream(new File(Client.fileManager.fontsDir, fontName));
            Font awtClientFont = Font.createFont(0, inputStream);
            awtClientFont = awtClientFont.deriveFont(0, size);
            ((InputStream)inputStream).close();
            return awtClientFont;
        }
        catch (Exception e) {
            e.printStackTrace();
            return new Font("default", 0, size);
        }
    }

    private static void extractZip(String zipFile, String outputFolder) {
        byte[] buffer = new byte[1024];
        try {
            File folder = new File(outputFolder);
            if (!folder.exists()) {
                folder.mkdir();
            }
            ZipInputStream zipInputStream = new ZipInputStream(new FileInputStream(zipFile));
            ZipEntry zipEntry = zipInputStream.getNextEntry();
            while (zipEntry != null) {
                int i;
                File newFile = new File(outputFolder + File.separator + zipEntry.getName());
                new File(newFile.getParent()).mkdirs();
                FileOutputStream fileOutputStream = new FileOutputStream(newFile);
                while ((i = zipInputStream.read(buffer)) > 0) {
                    fileOutputStream.write(buffer, 0, i);
                }
                fileOutputStream.close();
                zipEntry = zipInputStream.getNextEntry();
            }
            zipInputStream.closeEntry();
            zipInputStream.close();
        }
        catch (IOException e) {
            e.printStackTrace();
        }
    }
}

