/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.google.gson.Gson
 *  com.google.gson.GsonBuilder
 *  com.google.gson.JsonArray
 *  com.google.gson.JsonElement
 *  com.google.gson.JsonObject
 *  kotlin.jvm.internal.Intrinsics
 */
package net.aspw.client.visual.hud;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import java.util.Collection;
import kotlin.jvm.internal.Intrinsics;
import net.aspw.client.util.ClientUtils;
import net.aspw.client.value.FontValue;
import net.aspw.client.value.Value;
import net.aspw.client.visual.hud.HUD;
import net.aspw.client.visual.hud.element.Element;
import net.aspw.client.visual.hud.element.ElementInfo;
import net.aspw.client.visual.hud.element.Side;

public final class Config {
    private JsonArray jsonArray;

    public Config(String config) {
        Intrinsics.checkNotNullParameter((Object)config, (String)"config");
        this.jsonArray = new JsonArray();
        Object object = new Gson().fromJson(config, JsonArray.class);
        Intrinsics.checkNotNullExpressionValue((Object)object, (String)"Gson().fromJson(config, JsonArray::class.java)");
        this.jsonArray = (JsonArray)object;
    }

    public Config(HUD hud) {
        Intrinsics.checkNotNullParameter((Object)hud, (String)"hud");
        this.jsonArray = new JsonArray();
        for (Element element : hud.getElements()) {
            JsonObject elementObject = new JsonObject();
            elementObject.addProperty("Type", element.getName());
            elementObject.addProperty("X", (Number)element.getX());
            elementObject.addProperty("Y", (Number)element.getY());
            elementObject.addProperty("Scale", (Number)Float.valueOf(element.getScale()));
            elementObject.addProperty("HorizontalFacing", element.getSide().getHorizontal().getSideName());
            elementObject.addProperty("VerticalFacing", element.getSide().getVertical().getSideName());
            for (Value<?> value : element.getValues()) {
                elementObject.add(value.getName(), value.toJson());
            }
            this.jsonArray.add((JsonElement)elementObject);
        }
    }

    public final String toJson() {
        String string = new GsonBuilder().setPrettyPrinting().create().toJson((JsonElement)this.jsonArray);
        Intrinsics.checkNotNullExpressionValue((Object)string, (String)"GsonBuilder().setPrettyP\u2026reate().toJson(jsonArray)");
        return string;
    }

    public final HUD toHUD() {
        HUD hud = new HUD();
        try {
            for (JsonElement jsonObject : this.jsonArray) {
                try {
                    if (!(jsonObject instanceof JsonObject) || !((JsonObject)jsonObject).has("Type")) continue;
                    String type = ((JsonObject)jsonObject).get("Type").getAsString();
                    for (Class<? extends Element> elementClass : HUD.Companion.getElements()) {
                        String classType = elementClass.getAnnotation(ElementInfo.class).name();
                        if (!classType.equals(type)) continue;
                        Element element = elementClass.newInstance();
                        element.setX(((JsonObject)jsonObject).get("X").getAsInt());
                        element.setY(((JsonObject)jsonObject).get("Y").getAsInt());
                        element.setScale(((JsonObject)jsonObject).get("Scale").getAsFloat());
                        Object object = ((JsonObject)jsonObject).get("HorizontalFacing").getAsString();
                        Intrinsics.checkNotNullExpressionValue((Object)object, (String)"jsonObject[\"HorizontalFacing\"].asString");
                        Side.Horizontal horizontal = Side.Horizontal.Companion.getByName((String)object);
                        Intrinsics.checkNotNull((Object)((Object)horizontal));
                        object = ((JsonObject)jsonObject).get("VerticalFacing").getAsString();
                        Intrinsics.checkNotNullExpressionValue((Object)object, (String)"jsonObject[\"VerticalFacing\"].asString");
                        Side.Vertical vertical = Side.Vertical.Companion.getByName((String)object);
                        Intrinsics.checkNotNull((Object)((Object)vertical));
                        element.setSide(new Side(horizontal, vertical));
                        for (Value value : element.getValues()) {
                            if (!((JsonObject)jsonObject).has(value.getName())) continue;
                            JsonElement jsonElement = ((JsonObject)jsonObject).get(value.getName());
                            Intrinsics.checkNotNullExpressionValue((Object)jsonElement, (String)"jsonObject[value.name]");
                            value.fromJson(jsonElement);
                        }
                        if (((JsonObject)jsonObject).has("font")) {
                            Object v2;
                            block14: {
                                for (Object t : (Iterable)element.getValues()) {
                                    Value it = (Value)t;
                                    boolean bl = false;
                                    if (!(it instanceof FontValue)) continue;
                                    v2 = t;
                                    break block14;
                                }
                                v2 = null;
                            }
                            Value value = v2;
                            if (value != null) {
                                JsonElement jsonElement = ((JsonObject)jsonObject).get("font");
                                Intrinsics.checkNotNullExpressionValue((Object)jsonElement, (String)"jsonObject[\"font\"]");
                                value.fromJson(jsonElement);
                            }
                        }
                        Intrinsics.checkNotNullExpressionValue((Object)element, (String)"element");
                        hud.addElement(element);
                    }
                }
                catch (Exception e) {
                    ClientUtils.getLogger().error("Error while loading custom hud element from config.", (Throwable)e);
                }
            }
            Class<? extends Element>[] classArray = HUD.Companion.getElements();
            int n = 0;
            int n2 = classArray.length;
            while (n < n2) {
                boolean bl;
                Class<? extends Element> elementClass;
                block15: {
                    elementClass = classArray[n];
                    ++n;
                    if (!elementClass.getAnnotation(ElementInfo.class).force()) continue;
                    Iterable $this$none$iv = hud.getElements();
                    boolean $i$f$none = false;
                    if ($this$none$iv instanceof Collection && ((Collection)$this$none$iv).isEmpty()) {
                        bl = true;
                    } else {
                        for (Object element$iv : $this$none$iv) {
                            Element it = (Element)element$iv;
                            boolean bl2 = false;
                            if (!it.getClass().equals(elementClass)) continue;
                            bl = false;
                            break block15;
                        }
                        bl = true;
                    }
                }
                if (!bl) continue;
                Element element = elementClass.newInstance();
                Intrinsics.checkNotNullExpressionValue((Object)element, (String)"elementClass.newInstance()");
                hud.addElement(element);
            }
        }
        catch (Exception e) {
            ClientUtils.getLogger().error("Error while loading custom hud config.", (Throwable)e);
            return HUD.Companion.createDefault();
        }
        return hud;
    }
}

